c = 299792458; %m/s in vacuum

for cav=1 %1:12
    wllist = allpl.cav1(1).wllistcav;

    siv = []; vals = []; gss = [];
    for i=1:length(wllist)-3
        peaka = wllist(i);
        for j = i+1:length(wllist)-2
            peakb = wllist(j);
            for k = j+1:length(wllist-1)
                peakc = wllist(k);
                for h = k+1:length(wllist)
                    peakd = wllist(h);
                    dab = peaka - peakb;
                    dcd = peakc - peakd;
                    dac = peaka-peakc;
                    if dab > 46 & dcd > 46 & dac > 258  %min GSS 46 GHz, min ESS 258 GHz
                        if abs(dab - dcd) < sqrt(72) %spectrometer bandwidth 8 GHz
                            siv = [siv; peaka, peakb, peakc, peakd];
                            vals = [vals; i,j,k,h];
                            gss = [gss; 1/2*(dab+dcd)];
                        end 
                    end
                end
            end
        end
    end 

allsivpeaks = [siv(:,1); siv(:,2);siv(:,3); siv(:,4)];
wl = c./wllist;
wlallsivs = c./allsivpeaks;

[f,xi] = ksdensity(wl,'Bandwidth',0.01);
[f2,xi2]= ksdensity(wlallsivs,'Bandwidth',0.01);


figure; title(fprintf('Cavity %d',cav));
%subplot(2,2,1); plot(spectrum(:,1),sumdat/10); hold on; xline(wl) % PL data
xlabel('Wavelength, nm'); ylabel('PL intensity, a.u.')
subplot(2,2,2); plot(xi,f); hold on; xline(wl);
ylabel('PDF of all PL peaks'); xlabel('Wavelength, nm');
subplot(2,2,3); plot(xi2,f2); ylabel('PDF of all SiV peaks'); xlabel('Wavelength, nm');
subplot(2,2,4); xline(wl,'r'); hold on; xline(wlallsivs,'k'); xlabel('Wavelength, nm');

end 

%% 
%allpl = struct{};
allcavs = {wllistcav1, wllistcav2, wllistcav3, wllistcav4,wllistcav6,...
    wllistcav7,wllistcav8,wllistcav9,wllistcav10,wllistcav11,wllistcav12,wllistcav13};
for cav=2 %12 cavities 
    wllist = allcavs{cav};

    siv = []; vals = []; gss = [];
    for i=1:length(wllist)-3
        peaka = wllist(i);
        for j = i+1:length(wllist)-2
            peakb = wllist(j);
            for k = j+1:length(wllist-1)
                peakc = wllist(k);
                for h = k+1:length(wllist)
                    peakd = wllist(h);
                    dab = peaka - peakb;
                    dcd = peakc - peakd;
                    dac = peaka-peakc;
                    if dab > 46 & dcd > 46 & dac > 258  %min GSS 46 GHz, min ESS 258 GHz
                        if abs(dab - dcd) < sqrt(72) %spectrometer bandwidth 8 GHz
                            siv = [siv; peaka, peakb, peakc, peakd];
                            vals = [vals; i,j,k,h];
                            gss = [gss; 1/2*(dab+dcd)];
                        end 
                    end
                end
            end
        end
    end 

allsivpeaks = [siv(:,1); siv(:,2);siv(:,3); siv(:,4)];
wl = c./wllist;
wlallsivs = c./allsivpeaks;

[f,xi] = ksdensity(wl,'Bandwidth',0.01);
[f2,xi2]= ksdensity(wlallsivs,'Bandwidth',0.01);


figure; title(fprintf('Cavity %d',cav));
subplot(2,2,1); plot(spectrum(:,1),sumdat/10); hold on; xline(wl)
xlabel('Wavelength, nm'); ylabel('PL intensity, a.u.')
subplot(2,2,2); plot(xi,f); hold on; xline(wl);
ylabel('PDF of all PL peaks'); xlabel('Wavelength, nm');
subplot(2,2,3); plot(xi2,f2); ylabel('PDF of all SiV peaks'); xlabel('Wavelength, nm');
subplot(2,2,4); xline(wl,'r'); hold on; xline(wlallsivs,'k'); xlabel('Wavelength, nm');

end 

%% 

minnumpeaks = (length(unique(vals))+mod(length(unique(vals)),4))/4; %maximum number of peaks included in candidate siv list 
maxnumpeaks = length(unique(vals)); %maximum number of peaks included in candidate siv list 
q = 1;
for l = 9:length(gss)
    numpeaks = []; %how many unique peaks can be made
    combinds = [];
    combpeaks = [];
    p = 0; %counter to index the number of combinations returned 
    while p<101 %look for unique combinations of sets 
        for i=1:10000 %try not to run out of memory :s 
            [peaks, inds] = findminpeaks(vals,l); %peaks is the unique set of peaks, inds are the val inds used
            numpeaks = [numpeaks length(peaks)]; 
            if length(peaks) == maxnumpeaks
                p = p+1
                break
            end
            if i == 10000 & p == 0
                disp('No combinations found in 10,000 attempts.')
                return 
            end 
        end 
        if length(peaks) == maxnumpeaks %redundant UNLESS no successes in 10000 loops. 
            combinds = [combinds; transpose(inds)];
            combpeaks = [combpeaks; peaks];
        end
    end 
    
    multipeaks = struct();
    sivgss = []; 
    if length(combinds) < 101 
        sz = length(combinds);
    else
        sz = 101; %update if number of loops changes.
    end 
    for j=1:sz
            [numpeakcts, edge] = histcounts(vals(combinds(j,:),:));
            edge = edge+0.5; 
            multipeaks(j).multipeaks = edge(numpeakcts>1);
            sivgss = [sivgss; transpose(gss(combinds(j,:)))]; 
    end

    allpl.cav13(q).peaks.multipeaks = multipeaks;
    allpl.cav13(q).peaks.sivgss = sivgss;
    allpl.cav13(q).peaks.combinds = combinds;
    allpl.cav13(q).peaks.combpeaks = combpeaks;
% 
%     test = sort(transpose(allpl.cav1(q).peaks.combinds)); %sort only works on columns
%     %numuniquecombs = length(unique(transpose(test),'rows')); %unique only works on rows 
%     uniquecombs = unique(transpose(test),'rows');
% 
%     allpl.cav2(q).peaks.uniquecombs = uniquecombs;
    q = q+1;
end 

%% 

thresh = 400; %threshold for strained in GHZ
frac = []; 
for i=1:length(allpl.cav13)
    smol = length(allpl.cav13(i).peaks.sivgss(allpl.cav13(i).peaks.sivgss<thresh);
    big = length(allpl.cav13(i).peaks.sivgss(allpl.cav13(i).peaks.sivgss>thresh));
    frac = [frac big/(smol+big)];
end

figure; scatter(linspace(9,63,54),frac);
xlabel('Number of SiVs in Cavity 13');
ylabel('Fraction with GSS > 400 GHz');
ylabel('Fraction of SiVs with GSS > 400 GHz');
title('Average fraction of high GSS SiVs over 101 simulated trials')

%% now assume normal distribution
widths = []; locs = [];
for q = 22 %mean number of sivs to consider %14:30
    k = 1; 
    frac = [];
    while k<10001 %try 10000 times
        p = 0;
        while p<12 %generate 12 random numbers that all fall within the constraints given by individual devices (i.e. >min num of sivs) 
            center = q;
            rand = [];
            for i=1:12
                rand = [rand floor(normrnd(center,2))];
            end
            datastr = {allpl.cav1, allpl.cav2, allpl.cav3, allpl.cav4, allpl.cav6, allpl.cav7,...
                allpl.cav8, allpl.cav9, allpl.cav10, allpl.cav11, allpl.cav12, allpl.cav13};
            offset = [5 12 8 13 13 6 9 6 12 14 9 9]; %map to index 
            
            ind = rand - offset;
            p=length(ind(ind>0));
        end
        grspl = [];
        for i=1:12 %for each cavity, record the ground state splitting of one set of SiVs that satisfy the critera
            set = datastr{i}(ind(i)).peaks;
            ii = randsample(101,1); %generate a random set of sivs from the list of 101 that satisfy the critera 
            grspl = [grspl set.sivgss(ii,:)];
        end
        frac = [frac length(grspl(grspl>400))/length(grspl)]; %calculate the fraction of ground state splittings that were bigger than 400 GHz 
        k=k+1;
    end
    [f,xi] = ksdensity(frac); %we have a histogram, let's fit it and find the mean and std 
    scale = max(histcounts(frac));
    [vals,confs,fit_results,gofs,init,stop_condition] = fitpeaks(transpose(xi),transpose(f/max(f)*scale),'n',1);
    
    widths = [widths vals.widths];
    locs = [locs vals.locations];
    figure; hold on; histogram(frac); plot(xi,f/max(f)*scale); plot(fit_results{2});
    title(sprintf('Fraction of SiVs with GSS>400 GHz for <n> = %d SiVs per cavity ',q));
    xlabel('Fraction of SiVs with GSS>400 GHz');
    ylabel('Instances in 10,000 trials');
end 
%plot the final result 
figure; errorbar(linspace(14,30,17),locs,widths); hold on;
scatter(linspace(14,30,17),locs,'filled')
xlim([13 31]);
xlabel('Mean number of SiVs in cavities');
ylabel('Fraction of SiVs with GSS > 400 GHz');

%% histogram assuming minimum number of SiVs per cavity 

%first, minimum number of SIVs in each cavity 

datastr = {allpl.cav1, allpl.cav2, allpl.cav3, allpl.cav4, allpl.cav6, allpl.cav7,...
                allpl.cav8, allpl.cav9, allpl.cav10, allpl.cav11, allpl.cav12, allpl.cav13};
offset = [5 12 8 13 13 6 9 6 12 14 9 9];
grspl = [];
for i=1:12
    set = datastr{i}(1).peaks; %always take the first set of data, which corresponds to the min number of peaks. 
    ii = randsample(101,1); %but we still want a random siv within that first set of data 
    grspl = [grspl set.sivgss(ii,:)]; 
end

figure; histogram(grspl,40);
xlabel('Ground state splitting, GHz');
ylabel('Number of SiVs');
title('Histogram of SiV GSS assuming minimum # SiVs/cavity')

%%
frac = [];
widths = [];
locs = [];
    for i=1:10000
    datastr = {allpl.cav1, allpl.cav2, allpl.cav3, allpl.cav4, allpl.cav6, allpl.cav7,...
                    allpl.cav8, allpl.cav9, allpl.cav10, allpl.cav11, allpl.cav12, allpl.cav13};
    offset = [5 12 8 13 13 6 9 6 12 14 9 9];
    grspl = [];
    for i=1:12
        set = datastr{i}(1).peaks; %always take the first set of data, which corresponds to the min number of peaks. 
        ii = randsample(101,1); %but we still want a random siv within that first set of data 
        grspl = [grspl set.sivgss(ii,:)]; 
    end
    frac = [frac length(grspl(grspl>400))/length(grspl)];
end
[f,xi] = ksdensity(frac); %we have a histogram, let's fit it and find the mean and std 
scale = max(histcounts(frac));
[vals,confs,fit_results,gofs,init,stop_condition] = fitpeaks(transpose(xi),transpose(f/max(f)*scale),'n',1);

widths = [widths vals.widths];
locs = [locs vals.locations];
figure; hold on; histogram(frac); plot(xi,f/max(f)*scale); plot(fit_results{2});
title(sprintf('Fraction of SiVs with GSS>300 GHz for minimum # of SIVs per cavity'));
xlabel('Fraction of SiVs with GSS>400 GHz');
ylabel('Instances in 10,000 trials');

%%
%next, maximum number of SIVs in each cavity 

datastr = {allpl.cav1, allpl.cav2, allpl.cav3, allpl.cav4, allpl.cav6, allpl.cav7,...
                allpl.cav8, allpl.cav9, allpl.cav10, allpl.cav11, allpl.cav12, allpl.cav13};
maxp = [34 206 68 66 122 45 89 54 151 105 51 54];

grspl = [];
for i=1:12
    set = datastr{i}(maxp(i)).peaks; %always take the last one, corresponding to the max number of peaks 
    ii = randsample(101,1); %but we still want a random siv within that last set of data 
    grspl = [grspl set.sivgss(ii,:)]; 
end

figure; histogram(grspl,40);
xlabel('Ground state splitting, GHz');
ylabel('Number of SiVs');
title('Histogram of SiV GSS assuming maximum # SiVs/cavity')

%%
frac = [];
    for i=1 %lol of course, you're looking at every single siv so there is only one relevant value... 
    datastr = {allpl.cav1, allpl.cav2, allpl.cav3, allpl.cav4, allpl.cav6, allpl.cav7,...
                    allpl.cav8, allpl.cav9, allpl.cav10, allpl.cav11, allpl.cav12, allpl.cav13};
    maxp = [34 206 68 66 122 45 89 54 151 105 51 54];
    grspl = [];
    for i=1:12
        set = datastr{i}(maxp(i)).peaks; %always take the first set of data, which corresponds to the min number of peaks. 
        ii = randsample(101,1); %but we still want a random siv within that first set of data 
        grspl = [grspl set.sivgss(ii,:)]; 
    end
    frac = [frac length(grspl(grspl>400))/length(grspl)];
end
[f,xi] = ksdensity(frac); %we have a histogram, let's fit it and find the mean and std 
scale = max(histcounts(frac));
[vals,confs,fit_results,gofs,init,stop_condition] = fitpeaks(transpose(xi),transpose(f/max(f)*scale),'n',1);

widths = [widths vals.widths];
locs = [locs vals.locations];
figure; hold on; histogram(frac); plot(xi,f/max(f)*scale); plot(fit_results{2});
title(sprintf('Fraction of SiVs with GSS>300 GHz for maximum # of SIVs per cavity'));
xlabel('Fraction of SiVs with GSS>400 GHz');
ylabel('Instances in 10,000 trials');

%% 

%finally, assume a mean of 22 SiVs in the cavity 

p = 0;
while p<12 %generate 12 random numbers that all fall within the constraints given by individual devices (i.e. >min num of sivs) 
    center = 22;
    rand = [];
    for i=1:12
        rand = [rand floor(normrnd(center,2))];
    end
    datastr = {allpl.cav1, allpl.cav2, allpl.cav3, allpl.cav4, allpl.cav6, allpl.cav7,...
        allpl.cav8, allpl.cav9, allpl.cav10, allpl.cav11, allpl.cav12, allpl.cav13};
    offset = [5 12 8 13 13 6 9 6 12 14 9 9]; %map to index 
    
    ind = rand - offset;
    p=length(ind(ind>0));
end
grspl = [];
for i=1:12 %for each cavity, record the ground state splitting of one set of SiVs that satisfy the critera
    set = datastr{i}(ind(i)).peaks;
    ii = randsample(101,1); %generate a random set of sivs from the list of 101 that satisfy the critera 
    grspl = [grspl set.sivgss(ii,:)];
end
frac = length(grspl(grspl>400))/length(grspl); %calculate the fraction of ground state splittings that were bigger than 400 GHz 

figure; histogram(grspl,40);
xlabel('Ground state splitting, GHz');
ylabel('Number of SiVs');
title('Histogram of SiV GSS assuming 22 SiVs/cavity')
